

c-------------------------------------------------------------------

      subroutine MSbartoOnShellPPtopbot(mst1msbar,mst2msbar,sttmsbar,
     $     qt1, qt2, qts,
     $     msb1msbar, msb2msbar, stbmsbar,
     $     qb1, qb2, qbs,
     $     mtos, mbos, xmgl, asmz, mz,
     $     mst1os, mst2os, sttos,
     $     msb1os, msb2os, stbos)

c      include 'ShiftMSbarOSMSt1sqvar.f'
      complex*16 ShiftMSbarOSMSt1sq
     &  , ShiftMSbarOSMSt1sq1
c      include 'ShiftMSbarOSMSt2sqvar.f'
      complex*16 ShiftMSbarOSMSt2sq
     &  , ShiftMSbarOSMSt2sq1
c      include 'ShiftMSbarOSsttvar.f'
      complex*16 ShiftMSbarOSstt
     &  , ShiftMSbarOSstt1
c      include 'ShiftMSbarOSMSb1sqvar.f'
      complex*16 ShiftMSbarOSMSb1sq
     &  , ShiftMSbarOSMSb1sq1
c      include 'ShiftMSbarOSMSb2sqvar.f'
      complex*16 ShiftMSbarOSMSb2sq
     &  , ShiftMSbarOSMSb2sq1
c      include 'ShiftMSbarOSstbvar.f'
      complex*16 ShiftMSbarOSstb
     &  , ShiftMSbarOSstb1


c      include 'varcom2.h'
      double precision mst1, mst2, stt, mgl, mt, cf, gs, eps, pi, mue
      complex*16 i

      common /msbartoos/ mst1, mst2, stt, mgl, mt, cf, gs, eps, pi,
     $	                 mue, i
c      include 'varcom3.h'
      double precision msb1, msb2, stb, mb

      common /msbartoos3/ msb1, msb2, stb, mb

      double precision mst1msbar, mst2msbar, sttmsbar, qt1, qt2, qts,
     $                 mst1os,    mst2os,    sttos
      double precision msb1msbar, msb2msbar, stbmsbar, qb1, qb2, qbs,
     $                 msb1os,    msb2os,    stbos
      double precision mtos, mbos, asmz, as, mz, xmgl
      double precision shiftt1, shiftt2, shifttx
      double precision shiftb1, shiftb2, shiftbx
 
c$$$      write(*,*) 'variables in MSbartoOnShellPP:'
c$$$      write(*,*) real(mst1msbar), real(mst2msbar), real(sttmsbar),
c$$$     $           real(qt1), real(qt2), real(qts), real(mtos), 
c$$$     $           real(msb1msbar), real(msb2msbar), real(stbmsbar),
c$$$     $           real(qb1), real(qb2), real(qbs), real(mbos), 
c$$$     $           real(xmgl), real(asmz), real(mz)
      eps = 1d-6
      cf = 4d0/3d0
      pi = 3.14159265358979d0
      i = (0d0, 1d0)

      mst1 = mst1msbar
      mst2 = mst2msbar
      stt = sttmsbar
      mt = mtos
      msb1 = msb1msbar
      msb2 = msb2msbar
      stb = stbmsbar
      mb = mbos
      call alphasmt(asmz,mt,mz,as)
      gs = dsqrt(4d0 * pi * as)
      mgl = xmgl

      mue = qt1
c      include 'ShiftMSbarOSMSt1sqsum.f'
      ShiftMSbarOSMSt1sq = 
     & + ShiftMSbarOSMSt1sq1()
      shiftt1 = dreal(ShiftMSbarOSMSt1sq)
c      write(*,*) 'shiftt1:', real(shiftt1)
      mue = qt2
c      include 'ShiftMSbarOSMSt2sqsum.f'
      ShiftMSbarOSMSt2sq = 
     & + ShiftMSbarOSMSt2sq1()
      shiftt2 = dreal(ShiftMSbarOSMSt2sq)
c      write(*,*) 'shiftt2:', real(shiftt2)
      mue = qts
c      include 'ShiftMSbarOSsttsum.f'
      ShiftMSbarOSstt = 
     & + ShiftMSbarOSstt1()
      shifttx = dreal(ShiftMSbarOSstt)
c      write(*,*) 'shifttx:', real(shifttx)

      if ((mst1**2-shiftt1).ge.0d0) then
         mst1os = dsqrt(mst1**2 - shiftt1)
      else
         mst1os = 0d0
         write(*,*) 'no MSt1 OS'
      endif
      if ((mst2**2-shiftt2).ge.0d0) then
         mst2os = dsqrt(mst2**2 - shiftt2)
      else
         mst2os = 0d0
         write(*,*) 'no MSt2 OS'
      endif
      sttos = stt - shifttx

      mue = qb1
c      include 'ShiftMSbarOSMSb1sqsum.f'
      ShiftMSbarOSMSb1sq = 
     & + ShiftMSbarOSMSb1sq1()
      shiftb1 = dreal(ShiftMSbarOSMSb1sq)
      mue = qb2
c      include 'ShiftMSbarOSMSb2sqsum.f'
      ShiftMSbarOSMSb2sq = 
     & + ShiftMSbarOSMSb2sq1()
      shiftb2 = dreal(ShiftMSbarOSMSb2sq)
      mue = qbs
c      include 'ShiftMSbarOSstbsum.f'
      ShiftMSbarOSstb = 
     & + ShiftMSbarOSstb1()
      shiftbx = dreal(ShiftMSbarOSstb)

      msb1os = dsqrt(msb1**2 - shiftb1)
      msb2os = dsqrt(msb2**2 - shiftb2)
      stbos = stb - shiftbx




      write(*,*) 
      write(*,*) "MSbar to OnShell"
      write(*,*) "================"
      write(*,*)
      write(*,*) "MSt1, MSt2, stt"
      write(*,*) real(mst1msbar), real(mst2msbar), real(sttmsbar)
      write(*,*) real(mst1os), real(mst2os), real(sttos)
      write(*,*) real(shiftt1), real(shiftt2), real(shifttx)
      write(*,*) 
      write(*,*) "MSb1, MSb2, stb"
      write(*,*) real(msb1msbar), real(msb2msbar), real(stbmsbar)
      write(*,*) real(msb1os), real(msb2os), real(stbos)
      write(*,*) real(shiftb1), real(shiftb2), real(shiftbx)
      write(*,*) 

 100  continue

      end
